function varargout = Porownanie_Newton_BFGS(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Porownanie_Newton_BFGS_OpeningFcn, ...
                   'gui_OutputFcn',  @Porownanie_Newton_BFGS_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function Porownanie_Newton_BFGS_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;

guidata(hObject, handles);

function varargout = Porownanie_Newton_BFGS_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;

function oblicz_newton_Callback(hObject, eventdata, handles)
try
% Zmienne
hesjan = zeros(2,2);
tablica_gradient = zeros(2,1);
tablica_d = zeros(2,1);
syms x1 x2;

% Dane wejściowe
rownanie = get(handles.funkcja, 'String');
x_0 = eval(str2mat(get(handles.punkt_pocz, 'String')));
precyzja = get(handles.precyzja, 'String');
e = str2num(precyzja);

tablica_x(1,1) = x_0(1,1); 
tablica_x(2,1) = x_0(2,1);
pochodna_x1 = diff(rownanie,x1);
pochodna_x2 = diff(rownanie,x2);
gradient = [pochodna_x1;pochodna_x2];
set(handles.uitable2,'Data', {char(pochodna_x1); char(pochodna_x2)}); % Gradient - tabela
pochodna_x1_x1 = diff(pochodna_x1,x1);
pochodna_x1_x2 = diff(pochodna_x1,x2);
pochodna_x2_x1 = diff(pochodna_x2,x1);
pochodna_x2_x2 = diff(pochodna_x2,x2);
hesjan(1,1) = pochodna_x1_x1;
hesjan(1,2) = pochodna_x1_x2;
hesjan(2,1) = pochodna_x2_x1;
hesjan(2,2) = pochodna_x2_x2;
set(handles.uitable3,'Data', hesjan); % Hesjan - tabela
invhesjan = hesjan^(-1);
set(handles.uitable4,'Data', invhesjan); % Hesjan odwrotny - tabela
i = 1;
n = 2;

while(i < n)
    % Obliczanie danego x-ksa
    x1 = tablica_x(1,i);
    x2 = tablica_x(2,i);
    tablica_gradient(1,i) = subs(pochodna_x1);
    tablica_gradient(2,i) = subs(pochodna_x2);
    temp = invhesjan * tablica_gradient(:,i);
    tablica_d(:,i) = temp;
    tablica_x(:,i+1) = tablica_x(:,i) - tablica_d(:,i); % Tutaj zmień + na - 

    
    % Warunek stopu 1
    x3 = tablica_x(1,i+1);
    x4 = tablica_x(2,i+1);
    dowar1 = subs(pochodna_x1,{'x1' 'x2'}, {'x3' 'x4'});
    dowar2 = subs(pochodna_x2,{'x1' 'x2'}, {'x3' 'x4'});
    warunek1 = subs(dowar1); 
    warunek2 = subs(dowar2);
    
    if((warunek1 <= 10^-7) && (warunek2 <= 10^-7))
        war1 = true;
    else
        war1 = false;
    end
    
    % Warunek stopu 2
    warunek3 = sqrt((tablica_x(1,i+1)-tablica_x(1,i))^2+(tablica_x(2,i+1)-tablica_x(2,i))^2);
    
    if(warunek3<e)
        war2 = true;
    else
        war2 = false;
    end
    
    % Warunki
    if(war1==true || war2==true)
        i = i + 1;
    else
        n = n + 1;
        i = i + 1;
    end
    
    % Warunek kończący
    if(n > 300)
        n = n - 1;
    end
    
    colnames=cell(size(tablica_x,2),1);
    
    for i=1:size(tablica_x,2)
           colnames{i}=['x(',num2str(i-1),')'];
    end
    
    set(handles.uitable1,'Data', tablica_x, 'ColumnName', colnames); % X-ksy - tabela
    set(handles.kroki_newton,'String',['Liczba potrzebnych kroków: ' num2str(i-1)]); % Wypisanie liczby kroków
end
catch 
errordlg(sprintf('Nie wprowadzono wszystkich wartości poprawnie.\nSprawdź czy liczby są poprawnie wpisane np. 1.5 (kropka nie przecinek)\nFunkcja został wpisana błędnie'),'Błąd Newton');
end

function oblicz_bfgs_Callback(hObject, eventdata, handles)
try
% Zmienne
syms x1 x2;

% Dane
rownanie = get(handles.funkcja, 'String');
tablica_x(:,1) = eval(str2mat(get(handles.x00, 'String')));
tablica_x(:,2) = eval(str2mat(get(handles.x0, 'String')));
precyzja = get(handles.precyzja, 'String');
e = str2num(precyzja);
h = 1;
V = [1 0; 0 1];
tablica_v = V;

pochodna_x1 = diff(rownanie,x1);
pochodna_x2 = diff(rownanie,x2);

i = 1;
n = 2;

while(i < n)
    % Obliczanie a
    a_wieksze = tablica_x(:,i+1);
    a_mniejsze = tablica_x(:,i);
    a = a_wieksze - a_mniejsze;
    tablica_a(:,i) = a;
    
     % Obliczanie s
    x1 = tablica_x(1,i+1);
    x2 = tablica_x(2,i+1);
    s_wieksze = [subs(pochodna_x1);subs(pochodna_x2)];
    x1 = tablica_x(1,i);
    x2 = tablica_x(2,i);
    s_mniejsze = [subs(pochodna_x1);subs(pochodna_x2)];
    s = s_wieksze - s_mniejsze;
    tablica_s(:,i) = s;
    
    % Obliczanie A
    a_trans =  transpose(tablica_a(:,i));
    A = (tablica_a(:,i)*a_trans)/(a_trans*tablica_s(:,i));
    tablica_A = A;
    
    % Obliczanie C
    s_trans = transpose(tablica_s(:,i));
    C = (s_trans*V*tablica_s(:,i))/(a_trans*tablica_s(:,i));
    tablica_C = C;
    
    % Obliczanie D
    D = -(tablica_a(:,i)*s_trans*V+V*tablica_s(:,i)*a_trans)/(a_trans*tablica_s(:,i));
    
    % Obliczanie V+1
    V = V+(1+tablica_C)*tablica_A+D;
    tablica_v = [tablica_v V];
    
    % Obliczanie d
    x1 = tablica_x(1,i+1);
    x2 = tablica_x(2,i+1);
    pochodna_d = [subs(pochodna_x1);subs(pochodna_x2)];
    d = -V*pochodna_d;

    % Obliczanie x+1
    tablica_x(:,i+2) = tablica_x(:,i+1)+h*d;
    
    % Warunek stopu
    xip1 = tablica_x(1,i+1);
    xip2 = tablica_x(2,i+1);
    xi1 = tablica_x(1,i+2);
    xi2 = tablica_x(2,i+2);

    warunek = sqrt((xi1-xip1)^2+(xi2-xip2)^2);
    
    if(warunek < e)
        war = true;
    else
        war = false;
    end
    
    if(war==true)
        i = i + 1; % Koniec
    else
        n = n + 1;
        i = i + 1;
    end 
    % Warunek kończący
    if(n > 300)
        n = n - 1;
    end
    
    end
 colnames=cell(size(tablica_x,2),1);
    
    for i=1:size(tablica_x,2)
           colnames{i}=['x(',num2str(i-2),')'];
     set(handles.uitable5,'Data', tablica_v); % V - tabela
     set(handles.uitable6,'Data', tablica_x, 'ColumnName', colnames); % X-ksy - tabela
     set(handles.kroki_bfgs,'String',['Liczba potrzebnych kroków: ' num2str(i-1)]); % Wypisanie liczby kroków
end
catch 
errordlg(sprintf('Nie wprowadzono wszystkich wartości poprawnie.\nSprawdź czy liczby są poprawnie wpisane np. 1.5 (kropka nie przecinek)\nFunkcja został wpisana błędnie'),'Błąd BFGS');
end
